#include "LKH.h"
#include "Genetic.h"

/*
 * This file contains the main function of the program.
 */


//̦huBzMaxJobJob
#define MaxJob	   250
#define BigValue   99999
int     NJob;

typedef struct
{
  int   solution[MaxJob];  //sX
  long int   energy;            //sXؼШƭ
  long int   currentTime;
} memberType;

/* Annealing Schedule */
float INITIAL_TEMPERATURE;
float FINAL_TEMPERATURE;
float ALPHA_Value;
float temperature;
long STEPS_PER_CHANGE;

/* Return a random number between 0 and 1 */
#define getSRand()	((float)rand() / (float)RAND_MAX)

/* Return an integer from 0..(x-1) */
#define getRand(x)	(int)((x) * getSRand())

int solutionVisited=0;
int isFinal=0;

FILE *out, *out2, *infile;
char outfilename[80];
char filename[80];
int   objArray[100];
float averageTime=0;
int   bestSeq[MaxJob];
int   tempSeq[MaxJob];
float averageObj,stdObj;
int   intTarget=0;
int   Target=0;
int   output=0;
int   initSolution;

double setupTime[MaxJob][MaxJob];
double processTime[MaxJob];
double initSetup[MaxJob];

int setupTimeL[MaxJob][MaxJob];
int processTimeL[MaxJob];
int initSetupL[MaxJob];

int setupTimeU[MaxJob][MaxJob];
int processTimeU[MaxJob];
int initSetupU[MaxJob];
float ExpectedValue;


int LKH()
{
	
    GainType Cost, OldOptimum;
    double Time, LastTime = GetTime();

	ReadProblem();
	//srand(0);

    if (SubproblemSize > 0) {
        if (DelaunayPartitioning)
            SolveDelaunaySubproblems();
        else if (KarpPartitioning)
            SolveKarpSubproblems();
        else if (KCenterPartitioning)
            SolveKCenterSubproblems();
        else if (KMeansPartitioning)
            SolveKMeansSubproblems();
        else if (RohePartitioning)
            SolveRoheSubproblems();
        else if (MoorePartitioning || SierpinskiPartitioning)
            SolveSFCSubproblems();
        else
            SolveTourSegmentSubproblems();
        return EXIT_SUCCESS;
    }
    AllocateStructures();
    CreateCandidateSet();
    InitializeStatistics();

    if (Norm != 0)
        BestCost = PLUS_INFINITY;
    else {
        /* The ascent has solved the problem! */
        Optimum = BestCost = (GainType) LowerBound;
        UpdateStatistics(Optimum, GetTime() - LastTime);
        RecordBetterTour();
        RecordBestTour();
        WriteTour(OutputTourFileName, BestTour, BestCost);
        WriteTour(TourFileName, BestTour, BestCost);
        Runs = 0;
    }

    /* Find a specified number (Runs) of local optima */
    for (Run = 1; Run <= Runs; Run++) {
        LastTime = GetTime();
        Cost = FindTour();      /* using the Lin-Kernighan heuristic */
        if (MaxPopulationSize > 1) {
            /* Genetic algorithm */
            int i;
            for (i = 0; i < PopulationSize; i++) {
                GainType OldCost = Cost;
                Cost = MergeTourWithIndividual(i);
                if (TraceLevel >= 1 && Cost < OldCost) {
                    printff("  Merged with %d: Cost = " GainFormat, i + 1,
                            Cost);
                    if (Optimum != MINUS_INFINITY && Optimum != 0)
                        printff(", Gap = %0.4f%%",
                                100.0 * (Cost - Optimum) / Optimum);
                    printff("\n");
                }
            }
            if (!HasFitness(Cost)) {
                if (PopulationSize < MaxPopulationSize) {
                    AddToPopulation(Cost);
                    if (TraceLevel >= 1)
                        PrintPopulation();
                } else if (Cost < Fitness[PopulationSize - 1]) {
                    i = ReplacementIndividual(Cost);
                    ReplaceIndividualWithTour(i, Cost);
                    if (TraceLevel >= 1)
                        PrintPopulation();
                }
            }
        } else if (Run > 1)
            Cost = MergeBetterTourWithBestTour();
        if (Cost < BestCost) {
            BestCost = Cost;
            RecordBetterTour();
            RecordBestTour();
            WriteTour(OutputTourFileName, BestTour, BestCost);
            WriteTour(TourFileName, BestTour, BestCost);
        }
        OldOptimum = Optimum;
        if (Cost < Optimum) {
            if (FirstNode->InputSuc) {
                Node *N = FirstNode;
                while ((N = N->InputSuc = N->Suc) != FirstNode);
            }
            Optimum = Cost;
       //     printff("*** New optimum = " GainFormat " ***\n\n", Optimum);
        }
        Time = fabs(GetTime() - LastTime);
        UpdateStatistics(Cost, Time);
        if (TraceLevel >= 1 && Cost != PLUS_INFINITY) {
            printff("Run %d: Cost = " GainFormat, Run, Cost);
            if (Optimum != MINUS_INFINITY && Optimum != 0)
                printff(", Gap = %0.4f%%",
                        100.0 * (Cost - Optimum) / Optimum);
            printff(", Time = %0.2f sec. %s\n\n", Time,
                    Cost < Optimum ? "<" : Cost == Optimum ? "=" : "");
        }
        if (StopAtOptimum && Cost == OldOptimum && MaxPopulationSize >= 1) {
            Runs = Run;
            break;
        }
        if (PopulationSize >= 2 &&
            (PopulationSize == MaxPopulationSize ||
             Run >= 2 * MaxPopulationSize) && Run < Runs) {
            Node *N;
            int Parent1, Parent2;
            Parent1 = LinearSelection(PopulationSize, 1.25);
            do
                Parent2 = LinearSelection(PopulationSize, 1.25);
            while (Parent2 == Parent1);
            ApplyCrossover(Parent1, Parent2);
            N = FirstNode;
            do {
                int d = C(N, N->Suc);
                AddCandidate(N, N->Suc, d, INT_MAX);
                AddCandidate(N->Suc, N, d, INT_MAX);
                N = N->InitialSuc = N->Suc;
            }
            while (N != FirstNode);
        }
        SRandom(++Seed);
    }
  //  PrintStatistics();
    return EXIT_SUCCESS;
}


//X
void computeExpectValue( memberType *member)
{
   float ObjValue; 
   float ShortObj;
   int int1, int2;
   float currentTime=0;
   int i=0,j=0;

   for (i=0;i<NJob;i++) {
       processTime[i]= (processTimeL[i] + processTimeU[i])/2.0; 
   }
   //initial setup time
   for (i=0;i<NJob;i++) {
       initSetup[i]= (initSetupL[i] + initSetupU[i])/2.0; 
   }

   //sequence dependent setup time
   for (i=0;i<NJob;i++) {
       for (j=0;j<NJob;j++)  {
		   setupTime[i][j]=(setupTimeL[i][j]+setupTimeU[i][j])/2.0;
	   }
   }
   //p쥻ؼШƭ
   for (i=0;i<NJob;i++) {
       int2=member->solution[i];
 	   if (i==0) {
	      currentTime=initSetup[int2]+processTime[int2];
	   }
	   else {
	      int1=member->solution[i-1];
	 	  int2=member->solution[i];
		  currentTime=currentTime+setupTime[int1][int2]+processTime[int2];
	   }
   }
   ExpectedValue=currentTime;
}

//pؼЭȨ
void computeEnergy( memberType *member)
{
   int ObjValue; 
   int int1, int2;
   int currentTime=0;
   int i=0,j=0;
   int  allZero=1;

   //printf("NJob=%d\n",NJob);
   /*
   // 15_1.0_1.0_1.00_03.txt
   member->solution[0]=4;
   member->solution[1]=7;
   member->solution[2]=6;
   member->solution[3]=14;
   member->solution[4]=9;
   member->solution[5]=12;
   member->solution[6]=1;
   member->solution[7]=10;
   member->solution[8]=8;
   member->solution[9]=2;
   member->solution[10]=15;
   member->solution[11]=5;
   member->solution[12]=3;
   member->solution[13]=13;
   member->solution[14]=11;
  */
   /*
   member->solution[0]=5;
   member->solution[1]=1;
   member->solution[2]=4;
   member->solution[3]=6;
   member->solution[4]=2;
   member->solution[5]=3;
   */
   /*
   if (solutionVisited>5418)
   {
	  printf("Sol (%d):", solutionVisited);
      for (i=0;i<NJob;i++) {
	      printf("%d ", member->solution[i]);
	  }
	  printf(", obj=%d\n", member->energy);
	  getchar();
   }
   */

   //p쥻ؼШƭ
   for (i=0;i<NJob;i++) {
       int2=member->solution[i];
 	   if (i==0) {
	      currentTime=initSetupU[int2]+processTimeU[int2];
	   }
	   else {
	      int1=member->solution[i-1];
	 	  int2=member->solution[i];
		  currentTime=currentTime+setupTimeU[int1][int2]+processTimeU[int2];
	   }
   }
  // printf("currentTime=%d\n", currentTime);

   //probust cost
   for (i=1;i<=NJob;i++) {
	   initSetup[i]=initSetupL[i]+processTimeL[i];
	//   printf("initSetup[%d]=%d\n", i, initSetup[i]);
       for (j=1;j<=NJob;j++)  {
           setupTime[i][j]=setupTimeL[i][j]+processTimeL[j];
	   }
   }
   for (i=0;i<NJob;i++) {
       int2=member->solution[i];
 	   if (i==0) {
	      initSetup[int2]=initSetupU[int2]+processTimeU[int2];
	//	  printf("initSetup_U[%d]=%d\n", int2, initSetup[int2]);
	   }
	   else {
	      int1=member->solution[i-1];
	 	  int2=member->solution[i];
		  setupTime[int1][int2]=setupTimeU[int1][int2]+processTimeU[int2];
	   }
   }

	//]w    
   for (j=1;j<=NJob; j++) route_cost[0][j]=initSetup[j];
   for (i=0;i<=NJob; i++) route_cost[i][0]=BigValue;

   for (i=1;i<=NJob;i++) {
	   for (j=1;j<=NJob; j++) {
	      if (i==j) route_cost[i][j]=BigValue;
		  else route_cost[i][j]=setupTime[i][j];
	    }
	}
   /*
	for (i=0;i<=NJob;i++) {
	    for (j=0;j<=NJob; j++) {
	        printf("%d ", route_cost[i][j]);
		}
	    printf("\n");
	}
	*/
	/*
	route_cost[0][0]=BigValue; route_cost[0][1]=34; route_cost[0][2]=36; route_cost[0][3]=30; route_cost[0][4]=34;
	route_cost[1][0]=BigValue; route_cost[1][1]=BigValue; route_cost[1][2]=41; route_cost[1][3]=35; route_cost[1][4]=26;
	route_cost[2][0]=BigValue; route_cost[2][1]=36; route_cost[2][2]=BigValue; route_cost[2][3]=35; route_cost[2][4]=26;
	route_cost[3][0]=BigValue; route_cost[3][1]=36; route_cost[3][2]=32; route_cost[3][3]=BigValue; route_cost[3][4]=27;
	route_cost[4][0]=BigValue; route_cost[4][1]=51; route_cost[4][2]=34; route_cost[4][3]=26; route_cost[4][4]=BigValue;
	*/

    //Call LHK
    Dimension=NJob+1;
	LKH();

	//LKH{ǰ檺L{ADimension=Dimension*2A]Xɭn^
	Dimension=Dimension/2;
   // printf("\n");

	//printff("Lower bound = %0.1f\n", LowerBound-BigValue);
	//printf("Dimension=%d\n", Dimension);
	//for (i=1;i<=Dimension;i++) printf("%d ", BestTour[i]-1);
	//printf(", Obj=%d\n", BestCost-BigValue);

	if (fabs(BestCost-LowerBound)<0.01)
	{
	//   printf("Optimal Soluton found......\n");
	}

	//printf("RC=%d", currentTime-(BestCost-BigValue));
  //  system("pause");

	
   	member->energy=currentTime-(BestCost-BigValue);
	member->currentTime = currentTime;
	if (member->energy<0)
	{
	   member->energy=BigValue;
	}

   solutionVisited++;
  // printf("member->energy=%d\n", member->energy);
 //  getchar();
}

void localSearch( memberType *member)
{

   int bestf, x,y,temp;
  // return ;

   bestf=member->energy;
   for (x=0;x<NJob-1;x++) {
       for (y=0;y<=x-1;y++) {
		   temp = member->solution[x];
           member->solution[x] = member->solution[y];
           member->solution[y] = temp;
		   computeEnergy(member);
		   if (bestf>member->energy) {
		      bestf=member->energy;
		   }
		   else {
   	          temp = member->solution[x];
              member->solution[x] = member->solution[y];
              member->solution[y] = temp;
		   }
	   }
   }
   computeEnergy(member);
}

int tweakSolution(memberType *member)
{
  int temp, i,k,x, y;
  int jobNo, intCount,intCount2;
  float prob;
  float objValue;
  float bestObjValue;
  int   intBestIndex=MaxJob;
  memberType newmember;

  prob=getSRand();

  if (prob<0.5)  //exchange 
  {
     x = getRand(NJob);
     if (x>=NJob) x=NJob-1;
     do {
        y = getRand(NJob);
        if (y>=NJob) y=NJob-1;
	 } while (x == y);

     temp = member->solution[x];
     member->solution[x] = member->solution[y];
     member->solution[y] = temp;
  }
  else if (prob<1.667) //insertion
  {
     x = getRand(NJob);
     if (x>=NJob) x=NJob-1;
	 do 
	 {
        y = getRand(NJob);
        if (y>=NJob) y=NJob-1;	
	 } while (y==x-1);

	 jobNo=member->solution[x];
	 intCount=0;
	 for (i=0;i<x;i++)
	 { 
		 tempSeq[intCount]=member->solution[i];
		 intCount++;
	 }
	 for (i=x+1;i<NJob;i++)
	 { 
		 tempSeq[intCount]=member->solution[i];
		 intCount++;
	 }
     for (k=0;k<y;k++) member->solution[k]=tempSeq[k];
     member->solution[y]=jobNo;
     for (k=y;k<NJob-1;k++) member->solution[k+1]=tempSeq[k]; 
  }
  else
  {
       x=rand()%NJob;
       y=x+1+rand()%3;
	   if (y>NJob-1) y=NJob-1;
       if (x>y) 
	   {
	      temp=x;
		  x=y;
		  y=temp;
	   }
	   for (i=x;i<=y;i++)
	   {
	      tempSeq[i]=member->solution[i];
	   }
	   intCount=0;
   	   for (i=x;i<=y;i++)
	   {
	      member->solution[i]=tempSeq[y-intCount];
		  intCount++;
	   }
  }
  return 0;
}

void initializeSolution( memberType *member )
{
   int ObjValue; 
   int int1, int2, x, y, temp;
   int currentTime=0;
   int i=0,j=0;
   int intStart=0, intVisited=0;
   memberType origMember;

   //Ubound-Value TSP
   for (i=0; i<NJob; i++) {
      member->solution[i]=i+1;
   }
   for (i=1;i<=NJob;i++) {
	   initSetup[i]=initSetupU[i]+processTimeU[i];
	//   printf("initSetup[%d]=%d\n", i, initSetup[i]);
       for (j=1;j<=NJob;j++)  {
           setupTime[i][j]=setupTimeU[i][j]+processTimeU[j];
	   }
   }
   for (i=0;i<NJob;i++) {
       int2=member->solution[i];
 	   if (i==0) {
	      initSetup[int2]=initSetupU[int2]+processTimeU[int2];
	//	  printf("initSetup_U[%d]=%d\n", int2, initSetup[int2]);
	   }
	   else {
	      int1=member->solution[i-1];
	 	  int2=member->solution[i];
		  setupTime[int1][int2]=setupTimeU[int1][int2]+processTimeU[int2];
	   }
   }
   //]w    
   for (j=1;j<=NJob; j++) route_cost[0][j]=initSetup[j];
   for (i=0;i<=NJob; i++) route_cost[i][0]=BigValue;

   for (i=1;i<=NJob;i++) {
	   for (j=1;j<=NJob; j++) {
	      if (i==j) route_cost[i][j]=BigValue;
		  else route_cost[i][j]=setupTime[i][j];
	    }
	}
   /*
   	for (i=0;i<=NJob;i++) {
	    for (j=0;j<=NJob; j++) {
	        printf("%d ", route_cost[i][j]);
		}
	    printf("\n");
	}
	*/
    //Call LHK
    Dimension=NJob+1;
	LKH();
	Dimension=Dimension/2;
	for (i=1;i<=Dimension;i++) {
		if ( (BestTour[i]-1)==0)  intStart=i;
	}
	intVisited=0;
	for (i=intStart+1;i<=Dimension;i++) {
	     member->solution[intVisited]= BestTour[i]-1;
		 intVisited++;
	}
	for (i=1;i<intStart;i++) {
		member->solution[intVisited]= BestTour[i]-1;
		intVisited++;
	}
	
    for (i=0;i<NJob;i++) printf("%d ", member->solution[i]);
	printf("obj=%d\n", BestCost-BigValue);
 
	for (i=0;i<NJob;i++)
		origMember.solution[i]= member->solution[i];

//	computeEnergy(member);
 //   printf("member->energy=%d\n", member->energy);
//	getchar();
	

	currentTime=BestCost-BigValue;
//	printf("currentTime=%d\n", currentTime);
   //p쥻ؼШƭ
   //Worse-Case TSP
   for (i=0;i<NJob;i++) {
       int2=member->solution[i];
 	   if (i==0) {
	      currentTime=initSetupU[int2]+processTimeU[int2];
	   }
	   else {
	      int1=member->solution[i-1];
	 	  int2=member->solution[i];
		  currentTime=currentTime+setupTimeU[int1][int2]+processTimeU[int2];
	   }
   }
 //printf("currentTime=%d\n", currentTime);

   //probust cost
   for (i=1;i<=NJob;i++) {
	   initSetup[i]=initSetupL[i]+processTimeL[i];
	//   printf("initSetup[%d]=%d\n", i, initSetup[i]);
       for (j=1;j<=NJob;j++)  {
           setupTime[i][j]=setupTimeL[i][j]+processTimeL[j];
	   }
   }
   for (i=0;i<NJob;i++) {
       int2=member->solution[i];
 	   if (i==0) {
	      initSetup[int2]=initSetupU[int2]+processTimeU[int2];
	//	  printf("initSetup_U[%d]=%d\n", int2, initSetup[int2]);
	   }
	   else {
	      int1=member->solution[i-1];
	 	  int2=member->solution[i];
		  setupTime[int1][int2]=setupTimeU[int1][int2]+processTimeU[int2];
	   }
   }

	//]w    
   for (j=1;j<=NJob; j++) route_cost[0][j]=initSetup[j];
   for (i=0;i<=NJob; i++) route_cost[i][0]=BigValue;

   for (i=1;i<=NJob;i++) {
	   for (j=1;j<=NJob; j++) {
	      if (i==j) route_cost[i][j]=BigValue;
		  else route_cost[i][j]=setupTime[i][j];
	    }
	}

  	for (i=0;i<=NJob;i++) {
	    for (j=0;j<=NJob; j++) {
	  //      printf("%d ", route_cost[i][j]);
		}
	//    printf("\n");
	}
	//Call LHK
    Dimension=NJob+1;
	LKH();

	//LKH{ǰ檺L{ADimension=Dimension*2A]Xɭn^
	Dimension=Dimension/2;
 /*
	printff("Lower bound = %0.1f\n", LowerBound);
	for (i=1;i<=Dimension;i++) printf("%d ", BestTour[i]-1);
	printf(", Obj=%d\n", BestCost);
	*/
	//ഫ
	intVisited=0;
	for (i=1;i<=Dimension;i++) {
		if ( (BestTour[i]-1)==0)  intStart=i;
	}
	/*
	for (i=intStart+1;i<=Dimension;i++) {
	     member->solution[intVisited]= BestTour[i]-1;
		 intVisited++;
	}
	for (i=1;i<intStart;i++) {
		member->solution[intVisited]= BestTour[i]-1;
		intVisited++;
	}
	*/

	for (i=0;i<NJob;i++)
		member->solution[i]=origMember.solution[i];

	//for (i=0;i<NJob;i++) printf("%d ", member->solution[i]);
	//printf("obj=%d\n", BestCost-BigValue);

	//printf("RC=%d", currentTime-(BestCost-BigValue));
    //system("pause");
  // printf("member->energy=%d\n", member->energy);
 //  getchar();
	member->currentTime=currentTime;
    member->energy=currentTime-(BestCost-BigValue);
   solutionVisited=0;
 /*
  printf("member->energy=%d\n", member->energy);
   computeEnergy(member);
    printf("member->energy=%d\n", member->energy);
	*/
}

void copySolution( memberType *dest, memberType *src )
{
  int i;

  for (i = 0 ; i < NJob ; i++) {
    dest->solution[i] = src->solution[i];
  }
  dest->energy = src->energy;
  dest->currentTime=src->currentTime;
}

void ReadData(char *filename)
{
   int value1, value2;
   int i,j;
   FILE *infile;

   infile=fopen(filename,"r");
   if (infile==NULL)
   {
      printf("cannot find %s\n", filename);
	  getchar();
	  exit(0);
   }
   fscanf(infile, "%d\n", &NJob);
   printf("NJob=%d\n", NJob);

   //processing time
   for (i=1;i<=NJob;i++)
   {
       fscanf(infile, "%d %d\n", &value1, &value2);
       processTimeL[i]=value1;
       processTimeU[i]=value2; 
  //     printf("processTimeL[i]=%d, processTimeU[i]=%d\n", processTimeL[i],processTimeU[i]);
   }

   //initial setup time
   for (i=1;i<=NJob;i++)
   {
       fscanf(infile, "%d %d\n", &value1, &value2);
       initSetupL[i]=value1;
       initSetupU[i]=value2; 
    //   printf("initSetupL[i]=%d, initSetupU[i]=%d\n", initSetupL[i],initSetupU[i]);
   }

   //sequence dependent setup time
   for (i=1;i<=NJob;i++) {
       for (j=1;j<=NJob;j++) {
		   fscanf(infile, "%d", &value1);
           setupTimeL[i][j]=value1;
	   }
   }
   for (i=1;i<=NJob;i++) {
       for (j=1;j<=NJob;j++) {
		   fscanf(infile, "%d", &value1);
           setupTimeU[i][j]=value1;
	   }
   }
   out=fopen("temp_data.txt","w");
   fprintf(out,"%d\n", NJob);
   for (i=1;i<=NJob;i++)
       fprintf(out,"%2d ", processTimeL[i]);
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++)
       fprintf(out,"%2d ", processTimeU[i]);
   fprintf(out,"\n");
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++)
       fprintf(out,"%2d ", initSetupL[i]);
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++)
       fprintf(out,"%2d ", initSetupU[i]);
   fprintf(out,"\n");
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++) {
	  for (j=1;j<=NJob;j++)  {
		  fprintf(out,"%2d ", setupTimeL[i][j]);
	  }
      fprintf(out,"\n");
   }
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++) {
	  for (j=1;j<=NJob;j++) {
	      fprintf(out,"%2d ", setupTimeU[i][j]);
	  }
      fprintf(out,"\n");
   }
   fprintf(out,"\n");
   fclose(out);
}



int main(int argc, char *argv[])
{
  memberType current, working, best;
  int   run,l,i,j;	
  int   timer=0, step, solution=0, useNew, accepted;
  int   Unchanged=0;
  long int   bestf;
  int   worstf;
  int   noReduced=0;
  int   tempMax=0;
  int   intFound=0;
  char  filename[80];
  int   MaxUnChanged;
  float TimeLimit, MaxTimeUsed;
  clock_t begin_time,end_time, last_time, last_showTime;

  //]wLKHѼƸ
  //u@Yi
  ReadParameters();
  //nܹLhT
  TraceLevel=0;
  //]w̤j
  MaxMatrixDimension = 10000;
	
  if (argc!=2)
  {
     printf("SARTSP.exe filename\n");
	 getchar();
	 exit(0);
  }

  strcpy(filename, argv[1]);
  ReadData(filename);

  //UCѼƤ~
  //STEPS_PER_CHANGE=NJob*200;
  STEPS_PER_CHANGE=NJob*10;
 // STEPS_PER_CHANGE=1;
  MaxUnChanged=10*STEPS_PER_CHANGE;
  INITIAL_TEMPERATURE=0.5;
  FINAL_TEMPERATURE=0.001;
  ALPHA_Value=0.90;

  TimeLimit=15*NJob;
  //TimeLimit=0.1*NJob;
  MaxTimeUsed=TimeLimit;

  printf("TimeLimit=%f, MaxTimeUsed=%f, MaxUnChanged=%d\n", TimeLimit, MaxTimeUsed, MaxUnChanged);
  bestf=99999;
  
  if (NJob>=100) run=1;
  else if (NJob==50) run=2;
  else if (NJob==30) run=3;
  else run=5;

  run=1;
  for (l=1;l<=run;l++)
  {      
	  srand(l);
      begin_time=clock();
	  last_time=begin_time;
	  last_showTime=begin_time;
	  temperature=INITIAL_TEMPERATURE;
      isFinal=0;
	  Unchanged=0;
	  solutionVisited=0;
      noReduced=0;
	  bestf=999999;
      //ͪ
      initializeSolution( &current );
      computeEnergy(&current );
	  printf("initial.energy=%d\n", current.energy);
	  initSolution=current.energy;
      copySolution( &best, &current);
      copySolution( &working, &current);

      while (temperature > FINAL_TEMPERATURE)
	  {
		  srand(solutionVisited);
	     accepted = 0;
         /* Monte Carlo Step */
         for (step = 0 ; step < STEPS_PER_CHANGE ; step++) 
		 {
             useNew = 0;
            //ͤU@Ӹ 
            tweakSolution( &working );
        	computeEnergy( &working );	
			Unchanged++;
		//	printf("working.obj=%d\n", working.energy);
			if (working.energy <= current.energy) 
			{
               useNew = 1;
			}  
	        else 
			{
               float prob = getSRand();
               float delta = working.energy - current.energy;
               float calc = exp(-delta/temperature); 
			  // calc=(temperature/(temperature*temperature+delta*delta));
			  // printf("calc=%f\n", calc);
               if (calc > prob)
			   {
                  accepted++;
                  useNew = 1;
			   }
			}
            //nܧ{
	        if (useNew)
			{
               useNew = 0;
               copySolution( &current, &working );
               if (current.energy < best.energy)
			   {
                  copySolution( &best, &current );
                /* 
				  computeEnergy( &best );
				   printf("Bestf: ");
                  for (i=0;i<NJob;i++) {
	                  printf("%d ", best.solution[i]);
	              }
	              printf(", obj=%d\n", best.energy);
				  
				  computeEnergy( &working );
				   printf("Working: ");
                  for (i=0;i<NJob;i++) {
	                  printf("%d ", working.solution[i]);
	              }
	              printf(", obj=%d\n", working.energy);

				  computeEnergy( &current );
				  printf("Current:", solutionVisited);
                  for (i=0;i<NJob;i++) {
	                  printf("%d ", current.solution[i]);
	              }
	              printf(", obj=%d\n", current.energy);
				  getchar();
				  */
				  solution = 1;
				  Unchanged=0;
			//	  printf("Unchanged=%d\n", Unchanged);
				  last_time=clock();
			   }
			}
	        //nܧ{
	        else {
               copySolution( &working, &current);
			}
            end_time=clock();  	
            if (Unchanged>=MaxUnChanged) {
			   temperature=FINAL_TEMPERATURE;
	  		   step = STEPS_PER_CHANGE;
			   temperature=0;
			   printf("Unchanged=%d, MaxUnChanged=%d\n", Unchanged, MaxUnChanged);
	   		   printf("MaxUnChanged.......\n");
			   break;	
			}
   		    else if ( TimeLimit < (end_time-begin_time)/(float)CLOCKS_PER_SEC) {
			   temperature=FINAL_TEMPERATURE;
	  		   step = STEPS_PER_CHANGE;
			   temperature=0;
			   printf("TimeLimit.....\n");
			   break;
			}

		    if ( 20 < (end_time-last_showTime)/(float)CLOCKS_PER_SEC) {
	           printf("F=%s,R=%d, I=%d,sol=%d,temp=%.4f,bestf=%d,T=%.1f\n", 
			      filename, l, noReduced, solutionVisited, temperature, 
			      best.energy, (end_time-begin_time)/(float)CLOCKS_PER_SEC);
			   last_showTime=end_time;
			}
    	 } // for (step = 0 ; step < STEPS_PER_CHANGE ; step++) 

		 noReduced++;
     	 end_time=clock();  
        // computeEnergy( &best );
		 printf("F=%s,R=%d, I=%d,sol=%d,temp=%.4f,bestf=%d,T=%.1f\n",  filename, l, noReduced, solutionVisited, temperature, 
			 best.energy, (end_time-begin_time)/(float)CLOCKS_PER_SEC);
         temperature *= ALPHA_Value;
         if ( Unchanged>=MaxUnChanged) { 
		    temperature=FINAL_TEMPERATURE;
		    step = STEPS_PER_CHANGE;
		    break;
		 }
		 copySolution( &working, &current);
		 localSearch(&working);
	     if (working.energy<current.energy)
		    copySolution( &current, &working);
		 if (current.energy<best.energy)
		 {
		    copySolution( &best, &current);
			Unchanged=0;
		 }

	  }
	  objArray[l-1]=best.energy;
      if (bestf > best.energy) {
	     bestf=best.energy;
	     for (i=0;i<NJob;i++) bestSeq[i]=best.solution[i];
	  }
	  if (bestf > worstf) worstf=bestf;
     
	  isFinal=1;
      end_time=clock(); 
	//  computeEnergy(&best);
	  printf(" %2d run:",l);
	  printf("objValue=%d, ", best.energy);
      printf("time used =%.3f, ",(end_time-begin_time)/(float)CLOCKS_PER_SEC);
      averageTime=averageTime + (end_time-begin_time)/(float)CLOCKS_PER_SEC;
	  printf("solutionVisited=%ld\n",solutionVisited);
  }
  //getchar();
  output=1;
  for (i=0;i<NJob;i++) best.solution[i]=bestSeq[i];
   computeEnergy( &best );
   printf("objValue=%d\n",best.energy);  
   computeExpectValue( &best );
  for (i=0;i<NJob;i++) printf("%d ", best.solution[i]);
  printf("\n");

  if (intTarget==1)
     printf("filename=%s, target value=%d,  bestf=%d, CT=%d, EP=%.1f, time=%.2f\n", 
	         filename, Target, best.energy, best.currentTime,  ExpectedValue, (end_time-begin_time)/(float)CLOCKS_PER_SEC);
  else
     printf("filename=%s, bestf=%d, CT=%d,  EP=%.1f, time=%.2f\n", 
	         filename, best.energy, best.currentTime, ExpectedValue, (end_time-begin_time)/(float)CLOCKS_PER_SEC);

  out = fopen("0_result.csv", "a");
  fprintf(out,"filename=%s, ",filename);
  if (intTarget==1)
     fprintf(out,"target, %d, ",Target);

  fprintf(out,"obj=, %d, CT, %d, EP, %.1f,",bestf, best.currentTime, ExpectedValue);  
  fprintf(out,",(,");
  for (i=0;i<run-1;i++) {
     fprintf(out,"%d,", objArray[i]);
  }
  fprintf(out,"%d,),",objArray[run-1]);

  //ƻPзǮt
  averageObj=0;
  for (i=0;i<run;i++) {
     averageObj=averageObj+objArray[i];
  }
  averageObj=averageObj/(float)run;
  
  stdObj=0;
  for (i=0;i<run;i++) {
	  stdObj=stdObj+(objArray[i]-averageObj)*(objArray[i]-averageObj);
  }
  stdObj=sqrt(stdObj/run);

  fprintf(out," Avg,%.3f, std,%.3f, ",averageObj,stdObj);
  fprintf(out," Average_time,%.3f\n",averageTime/(float)run);
  fflush(out);
  fclose(out);
  strcpy(outfilename,filename);
  strcat(outfilename, ".txt");
  out2=fopen(outfilename,"w");
  fprintf(out2,"filename=%s, NJob,%d, ",filename, NJob);
  if (intTarget==1)
     fprintf(out2,"target, %d, ",Target);
  fprintf(out2,"obj=%d, CT=%d, EP=%.1f",bestf, best.currentTime,  ExpectedValue);

  fprintf(out2, "\n");
  fprintf(out2,"Job Seq: ");
  for (i=0;i<NJob;i++)
      fprintf(out2, "%d ", best.solution[i]);
  fclose(out2);

   for (i=0;i<NJob;i++)
       printf("%d ", best.solution[i]);

  //check error
  for (i=1;i<=NJob;i++) {
      intFound=0;
      for (j=0;j<=NJob;j++) {
	      if (i==best.solution[j])  {
		     intFound=1;
		     break;
		  }
	  }
	  if (intFound==0) {
	     printf("Cannot find job %d\n", i);
	     getchar();
	  }
  }


  return 0;
}