#include "LKH.h"
#include "Genetic.h"

/*
 * This file contains the main function of the program.
 */


//̦huBzMaxJobJob
#define MaxJob	   250
#define BigValue   9999999
int     NJob;

typedef struct
{
  int   solution[MaxJob];  //sX
  long int   energy;            //sXؼШƭ
  long int   currentTime;
} memberType;

/* Annealing Schedule */
float INITIAL_TEMPERATURE;
float FINAL_TEMPERATURE;
float Beta_Value;
float temperature;
long STEPS_PER_CHANGE;

/* Return a random number between 0 and 1 */
#define getSRand()	((float)rand() / (float)RAND_MAX)

/* Return an integer from 0..(x-1) */
#define getRand(x)	(int)((x) * getSRand())

int solutionVisited=0;
int isFinal=0;
int initialSolution=0;

FILE *out, *out2, *infile;
char outfilename[80];
char filename[80];
int   objArray[100];
float averageTime=0;
int   bestSeq[MaxJob];
int   tempSeq[MaxJob];
float averageObj,stdObj;
int   intTarget=0;
int   Target=0;
int   output=0;
int   initSolution;


double setupTime[MaxJob][MaxJob];
double processTime[MaxJob];
double initSetup[MaxJob];

int setupTimeL[MaxJob][MaxJob];
int processTimeL[MaxJob];
int initSetupL[MaxJob];

int setupTimeU[MaxJob][MaxJob];
int processTimeU[MaxJob];
int initSetupU[MaxJob];
float ExpectedValue;


int intFile=0;

int LKH()
{
	
    GainType Cost, OldOptimum;
    double Time, LastTime = GetTime();

	CandidateSetSymmetric=0;
	CandidateSetType=0;
	CoordType=0;
	DelaunayPartitioning=0;
	DelaunayPure=0;
	ExtraCandidateSetSymmetric=0;
	ExtraCandidateSetType=0;
	InitialTourAlgorithm=0;
	KarpPartitioning=0;
	KCenterPartitioning=0;
	KMeansPartitioning=0;
    MoorePartitioning=0;
	
    PatchingAExtended=0;
    PatchingARestricted=0;
    PatchingCExtended=0;
    PatchingCRestricted=0;
    ProblemType=0;
    RohePartitioning=0;
	SierpinskiPartitioning=0;
	SubproblemBorders=0;
	SubproblemsCompressed=0;
	WeightType=0;
	WeightFormat=0;


	ReadProblem();

    if (SubproblemSize > 0) {
        if (DelaunayPartitioning)
            SolveDelaunaySubproblems();
        else if (KarpPartitioning)
            SolveKarpSubproblems();
        else if (KCenterPartitioning)
            SolveKCenterSubproblems();
        else if (KMeansPartitioning)
            SolveKMeansSubproblems();
        else if (RohePartitioning)
            SolveRoheSubproblems();
        else if (MoorePartitioning || SierpinskiPartitioning)
            SolveSFCSubproblems();
        else
            SolveTourSegmentSubproblems();
        return EXIT_SUCCESS;
    }
    AllocateStructures();
    CreateCandidateSet();
    InitializeStatistics();

    if (Norm != 0)
        BestCost = PLUS_INFINITY;
    else {
        /* The ascent has solved the problem! */
        Optimum = BestCost = (GainType) LowerBound;
        UpdateStatistics(Optimum, GetTime() - LastTime);
        RecordBetterTour();
        RecordBestTour();
        WriteTour(OutputTourFileName, BestTour, BestCost);
        WriteTour(TourFileName, BestTour, BestCost);
        Runs = 0;
    }
	Runs=10;

    /* Find a specified number (Runs) of local optima */
    for (Run = 1; Run <= Runs; Run++) {
        LastTime = GetTime();
        Cost = FindTour();      /* using the Lin-Kernighan heuristic */
        if (MaxPopulationSize > 1) {
            /* Genetic algorithm */
            int i;
            for (i = 0; i < PopulationSize; i++) {
                GainType OldCost = Cost;
                Cost = MergeTourWithIndividual(i);
                if (TraceLevel >= 1 && Cost < OldCost) {
                    printff("  Merged with %d: Cost = " GainFormat, i + 1,
                            Cost);
                    if (Optimum != MINUS_INFINITY && Optimum != 0)
                        printff(", Gap = %0.4f%%",
                                100.0 * (Cost - Optimum) / Optimum);
                    printff("\n");
                }
            }
            if (!HasFitness(Cost)) {
                if (PopulationSize < MaxPopulationSize) {
                    AddToPopulation(Cost);
                    if (TraceLevel >= 1)
                        PrintPopulation();
                } else if (Cost < Fitness[PopulationSize - 1]) {
                    i = ReplacementIndividual(Cost);
                    ReplaceIndividualWithTour(i, Cost);
                    if (TraceLevel >= 1)
                        PrintPopulation();
                }
            }
        } else if (Run > 1)
            Cost = MergeBetterTourWithBestTour();
        if (Cost < BestCost) {
            BestCost = Cost;
            RecordBetterTour();
            RecordBestTour();
            WriteTour(OutputTourFileName, BestTour, BestCost);
            WriteTour(TourFileName, BestTour, BestCost);
        }
        OldOptimum = Optimum;
        if (Cost < Optimum) {
            if (FirstNode->InputSuc) {
                Node *N = FirstNode;
                while ((N = N->InputSuc = N->Suc) != FirstNode);
            }
            Optimum = Cost;
       //     printff("*** New optimum = " GainFormat " ***\n\n", Optimum);
        }
        Time = fabs(GetTime() - LastTime);
        UpdateStatistics(Cost, Time);
        if (TraceLevel >= 1 && Cost != PLUS_INFINITY) {
            printff("Run %d: Cost = " GainFormat, Run, Cost);
            if (Optimum != MINUS_INFINITY && Optimum != 0)
                printff(", Gap = %0.4f%%",
                        100.0 * (Cost - Optimum) / Optimum);
            printff(", Time = %0.2f sec. %s\n\n", Time,
                    Cost < Optimum ? "<" : Cost == Optimum ? "=" : "");
        }
        if (StopAtOptimum && Cost == OldOptimum && MaxPopulationSize >= 1) {
            Runs = Run;
            break;
        }
        if (PopulationSize >= 2 &&
            (PopulationSize == MaxPopulationSize ||
             Run >= 2 * MaxPopulationSize) && Run < Runs) {
            Node *N;
            int Parent1, Parent2;
            Parent1 = LinearSelection(PopulationSize, 1.25);
            do
                Parent2 = LinearSelection(PopulationSize, 1.25);
            while (Parent2 == Parent1);
            ApplyCrossover(Parent1, Parent2);
            N = FirstNode;
            do {
                int d = C(N, N->Suc);
                AddCandidate(N, N->Suc, d, INT_MAX);
                AddCandidate(N->Suc, N, d, INT_MAX);
                N = N->InitialSuc = N->Suc;
            }
            while (N != FirstNode);
        }
        SRandom(++Seed);
    }
   if (isShow==1) PrintStatistics();
	
   free_memory();

	//LKH{ǰ檺L{ADimension=Dimension*2A]Xɭn^
	Dimension=Dimension/2;
    return EXIT_SUCCESS;
}



//pؼЭȨ
void computeEnergy( memberType *member)
{
   int ObjValue; 
   int int1, int2;
   int currentTime=0;
   int i=0,j=0;
   int  allZero=1;

   //printf("NJob=%d\n",NJob);
   /*
   // 15_1.0_1.0_1.00_03.txt
   member->solution[0]=4;
   member->solution[1]=7;
   member->solution[2]=6;
   member->solution[3]=14;
   member->solution[4]=9;
   member->solution[5]=12;
   member->solution[6]=1;
   member->solution[7]=10;
   member->solution[8]=8;
   member->solution[9]=2;
   member->solution[10]=15;
   member->solution[11]=5;
   member->solution[12]=3;
   member->solution[13]=13;
   member->solution[14]=11;
  */
   /*
   member->solution[0]=5;
   member->solution[1]=1;
   member->solution[2]=4;
   member->solution[3]=6;
   member->solution[4]=2;
   member->solution[5]=3;
   */
   /*
   if (solutionVisited>5418)
   {
	  printf("Sol (%d):", solutionVisited);
      for (i=0;i<NJob;i++) {
	      printf("%d ", member->solution[i]);
	  }
	  printf(", obj=%d\n", member->energy);
	  getchar();
   }
   */

   //p쥻ؼШƭ
   for (i=0;i<NJob;i++) {
       int2=member->solution[i];
 	   if (i==0) {
	      currentTime=initSetupU[int2]+processTimeU[int2];
	   }
	   else {
	      int1=member->solution[i-1];
	 	  int2=member->solution[i];
		  currentTime=currentTime+setupTimeU[int1][int2]+processTimeU[int2];
	   }
   }
  // printf("currentTime=%d\n", currentTime);

   //probust cost
   for (i=1;i<=NJob;i++) {
	   initSetup[i]=initSetupL[i]+processTimeL[i];
	//   printf("initSetup[%d]=%d\n", i, initSetup[i]);
       for (j=1;j<=NJob;j++)  {
           setupTime[i][j]=setupTimeL[i][j]+processTimeL[j];
	   }
   }
   for (i=0;i<NJob;i++) {
       int2=member->solution[i];
 	   if (i==0) {
	      initSetup[int2]=initSetupU[int2]+processTimeU[int2];
	//	  printf("initSetup_U[%d]=%d\n", int2, initSetup[int2]);
	   }
	   else {
	      int1=member->solution[i-1];
	 	  int2=member->solution[i];
		  setupTime[int1][int2]=setupTimeU[int1][int2]+processTimeU[int2];
	   }
   }

	//]w    
   for (j=1;j<=NJob; j++) route_cost[0][j]=initSetup[j];
   for (i=0;i<=NJob; i++) route_cost[i][0]=BigValue;

   for (i=1;i<=NJob;i++) {
	   for (j=1;j<=NJob; j++) {
	      if (i==j) route_cost[i][j]=BigValue;
		  else route_cost[i][j]=setupTime[i][j];
	    }
	}
   /*
	for (i=0;i<=NJob;i++) {
	    for (j=0;j<=NJob; j++) {
	        printf("%d ", route_cost[i][j]);
		}
	    printf("\n");
	}
	*/
	/*
	route_cost[0][0]=BigValue; route_cost[0][1]=34; route_cost[0][2]=36; route_cost[0][3]=30; route_cost[0][4]=34;
	route_cost[1][0]=BigValue; route_cost[1][1]=BigValue; route_cost[1][2]=41; route_cost[1][3]=35; route_cost[1][4]=26;
	route_cost[2][0]=BigValue; route_cost[2][1]=36; route_cost[2][2]=BigValue; route_cost[2][3]=35; route_cost[2][4]=26;
	route_cost[3][0]=BigValue; route_cost[3][1]=36; route_cost[3][2]=32; route_cost[3][3]=BigValue; route_cost[3][4]=27;
	route_cost[4][0]=BigValue; route_cost[4][1]=51; route_cost[4][2]=34; route_cost[4][3]=26; route_cost[4][4]=BigValue;
	*/

    //Call LHK
    Dimension=NJob+1;
	LKH();

   // printf("\n");

	//printff("Lower bound = %0.1f\n", LowerBound-BigValue);
	//printf("Dimension=%d\n", Dimension);
	//for (i=1;i<=Dimension;i++) printf("%d ", BestTour[i]-1);
	//printf(", Obj=%d\n", BestCost-BigValue);

	if (fabs(BestCost-LowerBound)<0.01)
	{
	//   printf("Optimal Soluton found......\n");
	}

	//printf("RC=%d", currentTime-(BestCost-BigValue));
  //  system("pause");
		
   	member->energy=currentTime-(BestCost-BigValue);
	member->currentTime = currentTime;
	if (member->energy<0)
	{
	   member->energy=BigValue;
	}

   solutionVisited++;
  // printf("member->energy=%d\n", member->energy);
 //  getchar();
}



void ReadData(char *filename)
{
   int value1, value2;
   int i,j;
   FILE *infile;

   infile=fopen(filename,"r");
   if (infile==NULL)
   {
      printf("cannot find %s\n", filename);
	 // getchar();
	  exit(0);
   }
   fscanf(infile, "%d\n", &NJob);
   printf("NJob=%d\n", NJob);

   //processing time
   for (i=1;i<=NJob;i++)
   {
       fscanf(infile, "%d %d\n", &value1, &value2);
       processTimeL[i]=value1;
       processTimeU[i]=value2; 
  //     printf("processTimeL[i]=%d, processTimeU[i]=%d\n", processTimeL[i],processTimeU[i]);
   }

   //initial setup time
   for (i=1;i<=NJob;i++)
   {
       fscanf(infile, "%d %d\n", &value1, &value2);
       initSetupL[i]=value1;
       initSetupU[i]=value2; 
    //   printf("initSetupL[i]=%d, initSetupU[i]=%d\n", initSetupL[i],initSetupU[i]);
   }

   //sequence dependent setup time
   for (i=1;i<=NJob;i++) {
       for (j=1;j<=NJob;j++) {
		   fscanf(infile, "%d", &value1);
           setupTimeL[i][j]=value1;
	   }
   }
   for (i=1;i<=NJob;i++) {
       for (j=1;j<=NJob;j++) {
		   fscanf(infile, "%d", &value1);
           setupTimeU[i][j]=value1;
	   }
   }
   out=fopen("temp_data.txt","w");
   fprintf(out,"%d\n", NJob);
   for (i=1;i<=NJob;i++)
       fprintf(out,"%2d ", processTimeL[i]);
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++)
       fprintf(out,"%2d ", processTimeU[i]);
   fprintf(out,"\n");
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++)
       fprintf(out,"%2d ", initSetupL[i]);
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++)
       fprintf(out,"%2d ", initSetupU[i]);
   fprintf(out,"\n");
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++) {
	  for (j=1;j<=NJob;j++)  {
		  fprintf(out,"%2d ", setupTimeL[i][j]);
	  }
      fprintf(out,"\n");
   }
   fprintf(out,"\n");
   for (i=1;i<=NJob;i++) {
	  for (j=1;j<=NJob;j++) {
	      fprintf(out,"%2d ", setupTimeU[i][j]);
	  }
      fprintf(out,"\n");
   }
   fprintf(out,"\n");
   fclose(out);
}



int main(int argc, char *argv[])
{
  memberType current, working, best;
  int   run,l,i,j;	
  int   timer=0, step, solution=0, useNew, accepted;
  int   Unchanged=0;
  long int   bestf;
  float alphavalue;
  int   Nmax, IteValue;
  int   worstf;
  int   noReduced=0;
  int   tempMax=0;
  int   intFound=0;
  char  filename[80];
  char  outfilename[80];
  int   MaxUnChanged;
  float TimeLimit, MaxTimeUsed;
  FILE* inputFileNameList;
  char  strTemp[80];
  clock_t begin_time,end_time, last_time, last_showTime;

  //]wLKHѼƸ
  //u@Yi
  ReadParameters();
  //nܹLhT
  TraceLevel=0;
  //]w̤j
  MaxMatrixDimension = 10000;
	

  if (argc!=2)
  {
	 printf("пJѼ\n");
	 getchar();
     exit(0);
  }

  run=1;
  intFile = 1;

  strcpy(strTemp, argv[1]);
  strcpy(filename,strTemp);

	   
  printf("filename=%s\n", filename);
  ReadData(filename);

   //ͪ
  computeEnergy(&current );
	    
  printf(", initial.energy=%d\n", current.energy);
  getchar();

  return 0;
}