#include "LKH.h"
#include "Genetic.h"

/*
 * This file contains the main function of the program.
 */


//̦huBzMaxJobJob
#define BigValue   99999999
#define MaxJob	   10001
int     NJob;


typedef struct
{
  int   solution[MaxJob];  //sX
  double   energy;            //sXؼШƭ
} memberType;


/* Return a random number between 0 and 1 */
#define getSRand()	((float)rand() / (float)RAND_MAX)

/* Return an integer from 0..(x-1) */
#define getRand(x)	(int)((x) * getSRand())

int solutionVisited=0;
int isFinal=0;
int initialSolution=0;
int initNEHSolution=0;

FILE *out, *out2, *infile;
char outfilename[80];
char filename[80];
int   objArray[100];
float averageTime=0;
int   bestSeq[MaxJob];
int   tempSeq[MaxJob];
float averageObj,stdObj;
int   intTarget=0;
int   Target=0;
int   output=0;
int   initSolution;
float   initLB;
int   initialAlgorithm;
float timeUsed;


int intFile=0;
int  IsDebug=0;

clock_t begin_time,end_time, last_time, last_showTime;

int LKH()
{
	
    GainType Cost, OldOptimum;
    double Time, LastTime = GetTime();

	CandidateSetSymmetric=0;
	CandidateSetType=0;
	CoordType=0;
	DelaunayPartitioning=0;
	DelaunayPure=0;
	ExtraCandidateSetSymmetric=0;
	ExtraCandidateSetType=0;
	KarpPartitioning=0;
	KCenterPartitioning=0;
	KMeansPartitioning=0;
    MoorePartitioning=0;
	
    PatchingAExtended=0;
    PatchingARestricted=0;
    PatchingCExtended=0;
    PatchingCRestricted=0;
    ProblemType=0;
    RohePartitioning=0;
	SierpinskiPartitioning=0;
	SubproblemBorders=0;
	SubproblemsCompressed=0;
	WeightType=0;
	WeightFormat=0;

	
	AscentCandidates = 50;
	BackboneTrials = 0;
	Backtracking = 0;
	CandidateSetType = ALPHA;
	Excess = 1.0/Dimension;
	ExtraCandidates = 0;
	ExtraCandidateSetType = QUADRANT;
    Gain23Used = 1;
    GainCriterionUsed = 1;

	InitialPeriod = Dimension/2; if (InitialPeriod<100) InitialPeriod = 100;
	/*
	InitialTourAlgorithm= BORUVKA;
	InitialTourAlgorithm= GREEDY;
	InitialTourAlgorithm= MOORE;
    InitialTourAlgorithm= NEAREST_NEIGHBOR;
	InitialTourAlgorithm= QUICK_BORUVKA ; //D
	InitialTourAlgorithm= SIERPINSKI;     //D
	InitialTourAlgorithm= WALK;           

	InitialTourAlgorithm= WALK;
	initialAlgorithm=InitialTourAlgorithm;
	*/
	InitialTourFraction=1.0;


	InputTourFile=fopen(InitialTourFileName,"r");
   	printf("InitialTourFileName=%s\n", InitialTourFileName);

	if (InitialTourFileName!="")
	   InitialTourAlgorithm=-1;

	KickType = 0;
	Kicks = 1;
	MaxBreadth = INT_MAX;
	MaxCandidates = 5;
	MaxSwaps = 100;//Dimension;
	MaxTrials = 100; //Dimension;
	MoveType = 2; 
	PatchingA=1;
	PatchingC=0;
    NonsequentialMoveType= MoveType + PatchingA + PatchingC - 1;
	PopulationSize = 0;
	Precision = 100;
	RestrictedSearch = 1;
	Runs=1;
	Subgradient= 1;
	SubproblemSize = 0 ;
	SubsequentMoveType = 0;
	SubsequentPatching = 1;
	TraceLevel = 0;

	TimeLimit=DBL_MAX;
	
	TimeLimit=50;

	ReadProblem();

    if (SubproblemSize > 0) {
        if (DelaunayPartitioning)
            SolveDelaunaySubproblems();
        else if (KarpPartitioning)
            SolveKarpSubproblems();
        else if (KCenterPartitioning)
            SolveKCenterSubproblems();
        else if (KMeansPartitioning)
            SolveKMeansSubproblems();
        else if (RohePartitioning)
            SolveRoheSubproblems();
        else if (MoorePartitioning || SierpinskiPartitioning)
            SolveSFCSubproblems();
        else
            SolveTourSegmentSubproblems();
        return EXIT_SUCCESS;
    }
    AllocateStructures();
    CreateCandidateSet();
    InitializeStatistics();

    if (Norm != 0)
        BestCost = PLUS_INFINITY;
    else {
        /* The ascent has solved the problem! */
        Optimum = BestCost = (GainType) LowerBound;
        UpdateStatistics(Optimum, GetTime() - LastTime);
        RecordBetterTour();
        RecordBestTour();
        WriteTour(OutputTourFileName, BestTour, BestCost);
        WriteTour(TourFileName, BestTour, BestCost);
        Runs = 0;
    }

    /* Find a specified number (Runs) of local optima */
    for (Run = 1; Run <= Runs; Run++) {
        LastTime = GetTime();
        Cost = FindTour();      /* using the Lin-Kernighan heuristic */
        if (MaxPopulationSize > 1) {
            /* Genetic algorithm */
            int i;
            for (i = 0; i < PopulationSize; i++) {
                GainType OldCost = Cost;
                Cost = MergeTourWithIndividual(i);
                if (TraceLevel >= 1 && Cost < OldCost) {
                    printff("  Merged with %d: Cost = " GainFormat, i + 1,
                            Cost);
                    if (Optimum != MINUS_INFINITY && Optimum != 0)
                        printff(", Gap = %0.4f%%",
                                100.0 * (Cost - Optimum) / Optimum);
                    printff("\n");
                }
            }
            if (!HasFitness(Cost)) {
                if (PopulationSize < MaxPopulationSize) {
                    AddToPopulation(Cost);
                    if (TraceLevel >= 1)
                        PrintPopulation();
                } else if (Cost < Fitness[PopulationSize - 1]) {
                    i = ReplacementIndividual(Cost);
                    ReplaceIndividualWithTour(i, Cost);
                    if (TraceLevel >= 1)
                        PrintPopulation();
                }
            }
        } else if (Run > 1)
            Cost = MergeBetterTourWithBestTour();
        if (Cost < BestCost) {
            BestCost = Cost;
            RecordBetterTour();
            RecordBestTour();
            WriteTour(OutputTourFileName, BestTour, BestCost);
            WriteTour(TourFileName, BestTour, BestCost);
        }
        OldOptimum = Optimum;
        if (Cost < Optimum) {
            if (FirstNode->InputSuc) {
                Node *N = FirstNode;
                while ((N = N->InputSuc = N->Suc) != FirstNode);
            }
            Optimum = Cost;
            printff("*** New optimum = " GainFormat " ***\n\n", Optimum);
        }
        Time = fabs(GetTime() - LastTime);
        UpdateStatistics(Cost, Time);
        if (TraceLevel >= 1 && Cost != PLUS_INFINITY) {
            printff("Run %d: Cost = " GainFormat, Run, Cost);
            if (Optimum != MINUS_INFINITY && Optimum != 0)
                printff(", Gap = %0.4f%%",
                        100.0 * (Cost - Optimum) / Optimum);
            printff(", Time = %0.2f sec. %s\n\n", Time,
                    Cost < Optimum ? "<" : Cost == Optimum ? "=" : "");
        }
        if (StopAtOptimum && Cost == OldOptimum && MaxPopulationSize >= 1) {
            Runs = Run;
            break;
        }
        if (PopulationSize >= 2 &&
            (PopulationSize == MaxPopulationSize ||
             Run >= 2 * MaxPopulationSize) && Run < Runs) {
            Node *N;
            int Parent1, Parent2;
            Parent1 = LinearSelection(PopulationSize, 1.25);
            do
                Parent2 = LinearSelection(PopulationSize, 1.25);
            while (Parent2 == Parent1);
            ApplyCrossover(Parent1, Parent2);
            N = FirstNode;
            do {
                int d = C(N, N->Suc);
                AddCandidate(N, N->Suc, d, INT_MAX);
                AddCandidate(N->Suc, N, d, INT_MAX);
                N = N->InitialSuc = N->Suc;
            }
            while (N != FirstNode);
        }
        SRandom(++Seed);
    }
   if (isShow==1) PrintStatistics();
	
   free_memory();

	//LKH{ǰ檺L{ADimension=Dimension*2A]Xɭn^
	Dimension=Dimension/2;
    return EXIT_SUCCESS;
}

void LKH_Solution(memberType *member)
{
   double sumdif=0; 
   int i=0,j=0;
   int dummyIndex, index1, index2;
   int intCount=0;

     //Call LHK
    Dimension=NJob;
	LKH();

	initLB=LowerBound-0;
    printff("Lower bound = %0.1f\n", LowerBound-0);
	//printf("Dimension=%d\n", Dimension);
	//getchar();

	//printf("\n");
	for (i=1;i<=Dimension;i++) 
	{
	    printf("%d ", BestTour[i]);
		if (BestTour[i]==1)
		{
		   dummyIndex=i;
		}
	}

	printf("\n");
	
	
	for (i=1;i<=Dimension-1;i++) 
	{
		index1=BestTour[i]-1;
		index2=BestTour[i+1]-1;

	    sumdif+=route_cost[index1][index2];
		printf("i=%d: (%d - %d), dis=%f, sumdif=%f\n", 
			i, BestTour[i], BestTour[i+1], route_cost[index1][index2], sumdif);
	}
	index1=BestTour[Dimension]-1;
 	index2=BestTour[1]-1;
	sumdif+= route_cost[index1][index2];
	printf("i=%d: (%d - %d), dis=%f, sumdif=%f\n", 
			i, BestTour[Dimension], BestTour[1], route_cost[index1][index2], sumdif);
	
	
	out=fopen("3394_sol.txt", "w");
	for (i=1; i<=Dimension;i++)
		fprintf(out, "%d ", BestTour[i]); 

    end_time=clock();
    fprintf(out, "\nLKHTime=%.2f, obj=%f\n", (end_time-begin_time)/(float)CLOCKS_PER_SEC, sumdif/10000);  
	
	sumdif=0;
	for (i=1;i<=Dimension-1;i++) 
	{
		index1=BestTour[i]-1;
		index2=BestTour[i+1]-1;
	    sumdif+=route_cost[index1][index2];
		fprintf(out,"i=%d: (%d - %d), dis=%f, sumdif=%f\n", 
			i, BestTour[i], BestTour[i+1], route_cost[index1][index2]/10000.0, sumdif/10000.0);
	}
	index1=BestTour[Dimension]-1;
 	index2=BestTour[1]-1;
	sumdif+= route_cost[index1][index2];
	fprintf(out,"i=%d: (%d - %d), dis=%f, sumdif=%f\n", 
			i, BestTour[Dimension], BestTour[1], route_cost[index1][index2]/10000.0, sumdif/10000.0);


	fclose(out);
	
	//getchar();
//	if (dummyIndex>Dimension) dummyIndex=1;

    for (i=dummyIndex+1;i<=Dimension;i++) 
	{
	    member->solution[intCount]=BestTour[i]-1;
		intCount++;
	}
	for (i=1;i<=dummyIndex-1;i++) 
	{
	    member->solution[intCount]=BestTour[i]-1;
		intCount++;
	}
	member->energy=BestCost-0;
	if (member->energy<0)
	{
	   member->energy=BigValue;
	}

   solutionVisited++;
}



void ReadData(char *filename)
{
  int tempValue, tempBiggest;
  int i,j,k,h;
  int ioresult;
  
  printf("filename=%s\n", filename);
  infile=fopen(filename,"r");
  if (infile==NULL)
  {
	 printf("Can't find this file %s\n", filename);
	 getchar();
	 exit(0);
  }

  ioresult=fscanf(infile,"%d\n", &NJob);
  
  for (i=0;i<NJob;i++)
  {
	  for (j=0;j<NJob;j++)
	  {
          fscanf(infile, "%lf", &route_cost[i][j]);
		//  route_cost[i][j]=1;

		  route_cost[i][j]*=10000;
		  
		  if (i==j) route_cost[i][j]=BigValue;

		//  if (route_cost[i][j]==0 && i!=j) printf("route_cost[%d][%d]=%f\n", i, j, route_cost[i][j]);
	  }
  }

  for (i=0;i<NJob;i++)
  {
	  route_cost[i][i]=BigValue;
  }
}


void NNSolution(memberType *member)
{	
	int Seq[MaxJob], i, j;
	int Visited[MaxJob];
	int intProcessed = 0;
	int index1, index2, BestIndex;
	double obj, tempFloat;

	printf("NNSolution\n");

	tempFloat = 99999999;
	for (i = 0; i < NJob; i++) 
	{
		for (j = 0; j < NJob; j++)
		{
			if (i == j)
				continue;
			if (tempFloat > route_cost[i][j]) 
			{
				tempFloat = route_cost[i][j];
				index1 = i;
			}
		}
	}

	for (i = 0; i < NJob; i++)
		Visited[i] = 0;
	Visited[index1] = 1;
	intProcessed = 1;
	Seq[intProcessed] = index1;
	
	do 
	{
		tempFloat = 99999999;
		for (j = 0; j < NJob; j++)
		{
			if (i == j)
				continue;
			if (Visited[j] == 1)
				continue;
			if (tempFloat > route_cost[index1][j]) 
			{
				tempFloat = route_cost[index1][j];
				BestIndex = j;
			}
		}
		obj += route_cost[index1][BestIndex];
	//	printf("%d: from %d to %d, dis=%f,  sumDis=%f\n", 
	//		intProcessed, index1, BestIndex, route_cost[index1][BestIndex], obj);

		Visited[BestIndex] = 1;
		index1 = BestIndex;
		intProcessed++;
		Seq[intProcessed] = BestIndex;
	} while (intProcessed < NJob);

	obj += route_cost[index1][Seq[1]];
//	printf("%d: from %d to %d, dis=%f,  sumDis=%f\n", 
//			intProcessed, index1, BestIndex, route_cost[index1][Seq[1]], obj);
	printf("obj=%f\n", obj);

	for (i=0; i<NJob;i++)
	    member->solution[i]=Seq[i];
	member->energy=obj;


}



int main(int argc, char *argv[])
{
  memberType current, working, best, InitialMember;

  int   MaxRun, l,i,j, isBreak;	
  int   timer=0, step, solution=0, useNew, accepted, iter;
  char  filename[80];
  char  outfilename[80], str[80];
  int   MaxUnChanged;
  float TimeLimit, MaxTimeUsed, NEHTime, LKHTime;
  FILE* inputFileNameList;
  char  strTemp[80];


  //]wLKHѼƸ
  //u@Yi
  ReadParameters();
  //nܹLhT
  TraceLevel=0;
  //]w̤j
  MaxMatrixDimension = 10000;
	
  if (argc==1)
  {
     printf("Ƶ{--->");
     gets(filename);
  }
  else if (argc==2)
  {
     strcpy(filename,argv[1]);
     intTarget=0;
     Target=0;
  }  
  else if (argc==3)
  {
     strcpy(filename,argv[1]);
     strcpy(str,argv[2]);
     intTarget=1;
     Target=atoi(str);
  }

  infile=fopen(filename,"r");
  if (infile==NULL)
  {
	 printf("Can't find this file\n");
	 getchar();
	 exit(0);
  }

  ReadData(filename);
  
  //ͪɮ  
  begin_time=clock();  

  NNSolution(&InitialMember);
  initNEHSolution=InitialMember.energy; 
  initSolution=InitialMember.energy;    
  end_time=clock();
  NEHTime=(end_time-begin_time)/(float)CLOCKS_PER_SEC;
  printf("NEHTime=%.3f\n",NEHTime);
 
  //NѿXɮ
   strcpy(str, filename);
  strcat(str, "_temp.txt");
  InitialTourFileName=str;
  InputTourFileName=str;

  out=fopen(InitialTourFileName,"w");
  fprintf(out, "NAME : XXX\n");
  fprintf(out, "COMMENT : XXX\n");
  fprintf(out, "TYPE : TOUR\n");
  fprintf(out, "DIMENSION : %d\n", NJob);
  fprintf(out, "TOUR_SECTION\n");
  fprintf(out, "%d\n", 1); 
  for (i=0;i<NJob;i++)
	  fprintf(out, "%d\n", InitialMember.solution[i]+1); 
  fprintf(out, "-1\n"); 
  fprintf(out, "EOF\n");
  fflush(out);
  fclose(out);
 
  //IsLKH 
  initialAlgorithm=-1;
  isFirstComputed=1;
  begin_time=clock();  
  LKH_Solution(&InitialMember);
  printf("\nLKH energy =%f\n", InitialMember.energy);
  //^LKH
  for (i=0;i<NJob;i++) 
     current.solution[i]= InitialMember.solution[i]; 

  end_time=clock();
  LKHTime=(end_time-begin_time)/(float)CLOCKS_PER_SEC;
  printf("LKHTime=%.2f\n",LKHTime);  
 
  output =0;



  switch (initialAlgorithm) {
      case BORUVKA:
		  strcpy(str,"BORUVKA");
		  strcpy(initialSolName, filename);
		  strcat(initialSolName,"(BORUVKA).txt");
		  break;
	  case GREEDY:
		  strcpy(str,"GREEDY");
		  strcpy(initialSolName, filename);
		  strcat(initialSolName,"(GREEDY).txt");
		  break;
	  case MOORE:
		  strcpy(str,"MOORE");
  		  strcpy(initialSolName, filename);
		  strcat(initialSolName,"(MOORE).txt");
		  break;
	  case NEAREST_NEIGHBOR:
		  strcpy(str,"NEAREST_NEIGHBOR");
		  strcpy(initialSolName, filename);
		  strcat(initialSolName,"(NEAREST_NEIGHBOR).txt");
		  break;
	  case QUICK_BORUVKA:
		  strcpy(str,"QUICK_BORUVKA");
		  strcpy(initialSolName, filename);
		  strcat(initialSolName,"(QUICK_BORUVKA).txt");
		  break;
	  case SIERPINSKI:
		  strcpy(str,"SIERPINSKI");
		  strcpy(initialSolName, filename);
		  strcat(initialSolName,"(SIERPINSKI).txt");
		  break;
	  case WALK:
		  strcpy(str,"WALK");
  		  strcpy(initialSolName, filename);
		  strcat(initialSolName,"(WALK).txt");
		  break;
	  default:
		  strcpy(str,"no-specified");
	      strcpy(initialSolName, filename);
		  strcat(initialSolName,"(NEH).txt");
          break;
  }
  
  //ٻݭn@ഫ
  out=fopen(initialSolName,"w");
  for (i=0;i<2*NJob+1;i=i+2)
      fprintf(out, "%d ", initSol[i]);
  fprintf(out, "\n%.0f\n", initLB);
  fprintf(out, "%d\n", initSolVal);
  fclose(out);

  out=fopen("0_result.csv", "a");
  if (initialAlgorithm==-1)
  {
     fprintf(out, "....filename,%s, method, %s, LB, %.0f, NEH, %d, NEH_time, %.3f, LKH, %d, LKH_time, %.3f\n", 
	      filename, str, initLB, initNEHSolution, NEHTime, current.energy, LKHTime);   
  }
  else
  {
    fprintf(out, "filename,%s, method, %s, LB, %.0f, method_obj, %d, LKH, %d, LKH_time, %.3f\n", 
	      filename, str, initLB, initSolVal, current.energy, LKHTime);
  }

  fclose(out);

  //XѵMU
  strcpy(outfilename, filename);
  strcat(outfilename, "(init)");
  out=fopen(outfilename,"w");
  for (i=0;i<NJob;i++)
  {
	  fprintf(out, "%d ", current.solution[i]); 
  }
  fprintf(out, "%f\n", ceil(initLB-0.00001));
  fclose(out);

  


  return 0;
}